const inputEl = document.getElementById('query');

const search$ = fromEvent(inputEl, 'keyup').pipe(
  map(event => inputEl.value),
  startWith(inputEl.value),
  debounceTime(100),
  distinctUntilChanged()
);

let ajaxSubscription = null;
search$.subscribe(query => {
  if (ajaxSubscription) {
    ajaxSubscription.unsubscribe();
  }
  ajaxSubscription = createAjaxRequest(query)
    .subscribe(createOutputObserver());
});

function createAjaxRequest(query) {
  return ajax("http://localhost:3000/movies?q=" +
    encodeURIComponent(query) + "&_page=1&_limit=15"
  ).pipe(
    map(ajaxResult => ajaxResult.response.map(movie =>
      movie.title + " (" + movie.year + ")"
    ))
  );
}
